package be.iminds.ilabt.jfed.experimenter_gui.gts_editor;

import be.iminds.ilabt.jfed.experimenter_gui.gts_editor.views.EditableGtsDslView;
import be.iminds.ilabt.jfed.experimenter_gui.gts_editor.views.GTSViewsFactory;
import be.iminds.ilabt.jfed.gts.model.impl.FXGtsType;
import javafx.beans.property.SimpleStringProperty;
import javafx.beans.property.StringProperty;
import javafx.scene.layout.BorderPane;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * User: twalcari
 * Date: 5/18/2015
 * Time: 10:37
 */
public class GtsChildTypeEditor extends BorderPane {
    private static final Logger LOG = LoggerFactory.getLogger(GtsChildTypeEditor.class);

    private final FXGtsType type;

    private final StringProperty status = new SimpleStringProperty();
    private final EditableGtsDslView view;

    public GtsChildTypeEditor(FXGtsType type, GTSModelEditor parentEditor, GTSViewsFactory gtsViewsFactory) {
        this.type = type;

        view = gtsViewsFactory.createEditableGTSCanvasEditorView(new GTSModelEditor(type, parentEditor));
        setCenter(view.getView());
        status.bind(view.statusProperty());
    }

    public String getStatus() {
        return status.get();
    }

    public StringProperty statusProperty() {
        return status;
    }

    public FXGtsType getType() {
        return type;
    }

    public EditableGtsDslView getCurrentEditorView() {
        return view;
    }
}
